@echo off

SET x264=x264.exe

SET framerate=24
SET bitrate=30000
SET preset=medium
SET interlace=

IF "%1" == "" GOTO error
IF "%2" == "" GOTO error
IF "%1" == "%2" GOTO error

IF NOT "%4" == "" SET framerate=%4
IF NOT %framerate%==24 IF NOT %framerate%==25 IF NOT %framerate%==30 GOTO error

IF NOT "%3" == "" SET bitrate=%3
IF NOT "%5" == "" SET preset=%5

IF NOT %framerate%==24 SET interlace=--tff

GOTO run

:error
echo Runs [93m%x264%[0m to encode the video
echo Usage:
echo   [97m%~0[0m [96minput_file output_file [bitrate [framerate [preset]]][0m
echo   [96mbitrate[0m     default is [92m%bitrate%[0m
echo   [96mframerate[0m   can be [92m24[0m (for 23.976 and 24, default) / [92m25[0m / [92m30[0m (for 29.97)
echo   [96mpreset[0m      can be [92multrafast[0m/[92msuperfast[0m/[92mveryfast[0m/[92mfaster[0m/[92mfast[0m/[92mmedium[0m (default)/[92mslow[0m/[92mslower[0m/[92mveryslow[0m/[92mplacebo[0m
exit

:run
echo [97m%x264%[0m:  [96m%1[0m -^> [96m%2[0m  framerate [92m%framerate%[0m  bitrate [92m%bitrate%[0m  preset [92m%preset%[0m
%x264% --bitrate %bitrate% --tune film --bluray-compat --vbv-maxrate 40000 --vbv-bufsize 30000 --level 4.1 --keyint %framerate% --open-gop --slices 4 --colorprim "bt709" --transfer "bt709" --colormatrix "bt709" --sar 1:1 --b-pyramid none --preset %preset% %interlace% --pass 1 -o %2 %1
%x264% --bitrate %bitrate% --tune film --bluray-compat --vbv-maxrate 40000 --vbv-bufsize 30000 --level 4.1 --keyint %framerate% --open-gop --slices 4 --colorprim "bt709" --transfer "bt709" --colormatrix "bt709" --sar 1:1 --b-pyramid none --preset %preset% %interlace% --pass 2 -o %2 %1
